let lwip
const path = require('path')

try {
  // eslint-disable-next-line import/no-extraneous-dependencies, global-require, import/no-unresolved
  lwip = require('lwip')
} catch (e) {
  lwip = null
  console.log("WARNING! LWIP is not installed - image minification won't work.")
  console.log('You can try to run npm install.')
  console.log('If it does not help try to make npm install lwip work.')
}
const mkdirp = require('mkdirp')

module.exports = function imageResizer(file, targetDir, _width, _height) {
  let width = _width
  let height = _height
  if (lwip && (width || height)) {
    const tmp = path.basename(file).split('.')
    tmp.splice(-1, 1)
    const base = tmp.join('.')
    let targetFile = `${base}_thumb_`
    if (width) targetFile += width
    targetFile += 'x'
    if (height) targetFile += height
    targetFile += '.png'
    const ret = targetFile
    targetFile = path.resolve(targetDir, targetFile)
    lwip.open(file, (err, image) => {
      function doResize() {
        mkdirp(path.dirname(targetFile), () => {
          image
            .batch()
            .resize(width, height)
            .writeFile(targetFile, e => {
              if (e) console.log(e)
            })
        })
      }

      if (err) {
        console.log(err)
        return
      }
      const w = image.width()
      const h = image.height()
      if (width && height) {
        doResize()
      } else if (height) {
        if (h > height) {
          width = Math.round((height * w) / h)
          doResize()
        }
      } else if (width) {
        if (w > width) {
          height = Math.round((width * h) / w)
          doResize()
        }
      } else {
        console.log(new Error('Panic! Code should never get here!'))
      }
    })
    return ret
  }
  return path.basename(file)
}
