const toml = require('toml')
const path = require('path')

const readRedirectWorker = (content, obj) => {
  if (content === undefined) throw new Error('content is undefined')
  try {
    // eslint-disable-next-line no-param-reassign
    obj.metadata = toml.parse(content)
  } catch (e) {
    console.log(`${obj.filename}: Failed to parse metadata`)
    throw e
  }
  // eslint-disable-next-line no-param-reassign
  obj.content = obj.metadata.target
  // eslint-disable-next-line no-param-reassign
  obj.file = obj.file.split(path.sep).join('/')
  if (obj.file.match(/^redirects\/(.*)index\.toml/)) {
    // eslint-disable-next-line no-param-reassign
    obj.file = obj.file.replace(/^redirects\/(.*)index\.toml/, '$1')
  } else {
    // eslint-disable-next-line no-param-reassign
    obj.file = obj.file.replace(/^redirects\/(.*)\.toml/, '$1')
  }
  return obj
}

module.exports = obj => {
  console.log('Build step: ParseRedirects')
  return new Promise(resolve => {
    const redirects = []
    obj.redirects.forEach(page => {
      redirects.push(readRedirectWorker(page.content, page))
    })
    // eslint-disable-next-line no-param-reassign
    obj.redirects = redirects
    resolve(obj)
  })
}
