const markdown = require('./markdown')
const parseHugo = require('./parseHugo')
const print = require('./print')
const readFiles = require('./readFiles')
const tags = require('./tags')
const theme = require('./theme')
const urls = require('./urls')
const writeFiles = require('./writeFiles')
const sitemap = require('./sitemap')
const parseRedirects = require('./parseRedirects')
const configI = require('./config')

module.exports = config => {
  return () =>
    Promise.resolve(config)
      .then(configI)
      .then(readFiles)
      .then(parseHugo)
      .then(parseRedirects)
      .then(markdown)
      .then(urls)
      .then(sitemap)
      .then(tags)
      .then(theme)
      .then(writeFiles)
      .then(print)
}
