const fs = require('fs')

module.exports = function sitemapJob(obj) {
  console.log('Build step: Sitemap')
  return new Promise(resolve => {
    let file =
      '<?xml version="1.0" encoding="UTF-8"?>\n' +
      '<urlset\n' +
      'xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"\n' +
      'xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"\n' +
      'xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">\n'
    obj.pages.forEach(page => {
      if (!page.date) return
      file +=
        `${'<url>\n    <loc>https://ok1kvk.cz/'}${page.file}/</loc>\n` +
        `    <lastmod>${page.metadata.date.modification.toISOString()}</lastmod>\n` +
        `</url>\n`
    })
    file += '</urlset>'
    fs.writeFile(`${obj.config.builddir}/sitemap.xml`, file, () => {
      resolve(obj)
    })
  })
}
