const nunjucks = require('./nunjucks')

module.exports = function theme(_obj) {
  console.log('Build step: Theme')
  return new Promise((resolve, reject) => {
    let todo = 0
    const done = () => {
      todo -= 1
      if (todo <= 0) resolve(_obj)
    }

    const runJob = (obj, type) => {
      todo += 1
      nunjucks(obj, type, _obj.config)
        .then(data => {
          // eslint-disable-next-line no-param-reassign
          if (!obj.rendered) obj.rendered = []
          data.forEach(o => {
            obj.rendered.push(o)
          })

          done()
        })
        .catch(e => {
          reject(e)
        })
    }

    _obj.pages.forEach(page => {
      runJob(page, 'article')
    })
    _obj.tags.forEach(tag => {
      runJob(tag, 'tag')
    })
    _obj.redirects.forEach(redirect => {
      runJob(redirect, 'redirect')
    })
    if (todo <= 0) resolve(_obj)
  })
}
